diff --git a/pasmo-0.5.3_orig/asm.cpp b/pasmo-0.5.3/asm.cpp
index 87a328a..1d3d5a3 100644
--- a/pasmo-0.5.3_orig/asm.cpp
+++ b/pasmo-0.5.3/asm.cpp
@@ -1738,7 +1738,7 @@ void Asm::In::parsemuldiv (Tokenizer & tz, address & result,
 void Asm::In::parseplusmin (Tokenizer & tz, address & result,
 	bool required, bool ignored)
 {
-	parsemuldiv (tz, result, required, ignored);
+//	parsemuldiv (tz, result, required, ignored);
 	Token tok= tz.gettoken ();
 	TypeToken tt= tok.type ();
 	while (tt == TypePlus || tt == TypeMinus)
@@ -1766,7 +1766,7 @@ void Asm::In::parseplusmin (Tokenizer & tz, address & result,
 void Asm::In::parserelops (Tokenizer & tz, address & result,
 	bool required, bool ignored)
 {
-	parseplusmin (tz, result, required, ignored);
+//	parseplusmin (tz, result, required, ignored);
 	Token tok= tz.gettoken ();
 	TypeToken tt= tok.type ();
 	while (
@@ -1779,6 +1779,7 @@ void Asm::In::parserelops (Tokenizer & tz, address & result,
 		)
 	{
 		address guard;
+		parsemuldiv (tz, guard, required, ignored);
 		parseplusmin (tz, guard, required, ignored);
 		switch (tt)
 		{
@@ -1825,7 +1826,8 @@ void Asm::In::parsenot (Tokenizer & tz, address & result,
 	if (
 		tt == TypeNOT || tt == TypeBitNotOp ||
 		tt == TypeBoolNotOp ||
-		tt == TypePlus || tt == TypeMinus
+// modification for unary minus having higher precedence over multiplication (and so also over binary plus/minus)
+		tt == TypePlus //|| tt == TypeMinus
 		)
 	{
 		parsenot (tz, result, required, ignored);
@@ -1848,9 +1850,19 @@ void Asm::In::parsenot (Tokenizer & tz, address & result,
 			throw UnexpectedError;
 		}
 	}
+	else if ( tt == TypeMinus ) {
+		tz.ungettoken ();
+		// for unary minus pretend we have result 0 so far (emulation of a binary minus with the first operand = 0)
+		result = 0;
+		// and do (modified) relops (skipped parsemuldiv because "we already have first operand")
+		parseplusmin (tz, result, required, ignored);
+		parserelops (tz, result, required, ignored);
+	}
 	else
 	{
 		tz.ungettoken ();
+		parsemuldiv (tz, result, required, ignored);
+		parseplusmin (tz, result, required, ignored);
 		parserelops (tz, result, required, ignored);
 	}
 }
